'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.version = undefined;
exports.default = VueWebComponent;

var _construct = require('babel-runtime/core-js/reflect/construct');

var _construct2 = _interopRequireDefault(_construct);

var _freeze = require('babel-runtime/core-js/object/freeze');

var _freeze2 = _interopRequireDefault(_freeze);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _vue = require('vue');

var _vue2 = _interopRequireDefault(_vue);

var _skatejs = require('skatejs');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _fixBabelExtend = function (O) {
    var gOPD = O.getOwnPropertyDescriptor,
        gPO = O.getPrototypeOf || function (o) {
        return o.__proto__;
    },
        sPO = O.setPrototypeOf || function (o, p) {
        o.__proto__ = p;
        return o;
    },
        construct = typeof Reflect === 'object' ? _construct2.default : function (Parent, args, Class) {
        var Constructor,
            a = [null];
        a.push.apply(a, args);
        Constructor = Parent.bind.apply(Parent, a);
        return sPO(new Constructor(), Class.prototype);
    };

    return function fixBabelExtend(Class) {
        var Parent = gPO(Class);
        return sPO(Class, sPO(function Super() {
            return construct(Parent, arguments, gPO(this).constructor);
        }, Parent));
    };
}(Object);

// create a Custom Element class from a Vue component
function VueWebComponent(vueComponent, ElementClass) {
    ElementClass = ElementClass || _fixBabelExtend(function (_HTMLElement) {
        (0, _inherits3.default)(_class, _HTMLElement);

        function _class() {
            (0, _classCallCheck3.default)(this, _class);

            return (0, _possibleConstructorReturn3.default)(this, (_class.__proto__ || (0, _getPrototypeOf2.default)(_class)).apply(this, arguments));
        }

        return _class;
    }(HTMLElement));

    // NOTE! This mutates the given component spec, see
    // https://github.com/vuejs/vue/issues/7494. We do this up front (instead of
    // lazily in the element's renderer callback) so that when we're ready to
    // work with the spec it has already been mutated and there won't be any
    // surprises (or uglier code that conditionally checks for both forms of the
    // spec).
    var Component = _vue2.default.extend(vueComponent);

    // map from Vue prop types to SkateJS prop types
    var vuePropTypes = makeVuePropTypes(vueComponent.props);

    // contains scope ID of this element's Vue component as well as sub component
    // IDs
    var scopeIds = getAllScopeIds(vueComponent);

    // this will contain all CSS rules for this element's Vue component and
    // sub-components
    var matchingRules = null;

    return function (_withUpdate) {
        (0, _inherits3.default)(VueWebComponent, _withUpdate);

        function VueWebComponent() {
            var args = [],
                len = arguments.length;
            while (len--) args[len] = arguments[len];

            (0, _classCallCheck3.default)(this, VueWebComponent);

            var _this2 = (0, _possibleConstructorReturn3.default)(this, (ref = VueWebComponent.__proto__ || (0, _getPrototypeOf2.default)(VueWebComponent)).call.apply(ref, [this].concat(args)));

            _this2.vue_instance = new Component();
            _this2.vue_instancePromise = null;
            _this2.vue_mounted = false;
            return _this2;
            var ref;
        }

        /**
         * Define a renderer that mounts a Vue component in this element's shadow
         * root.
         */

        (0, _createClass3.default)(VueWebComponent, [{
            key: 'renderer',
            value: function renderer(root, render) {
                var this$1 = this;

                if (this.vue_mounted) {
                    return;
                }

                // mount the component
                this.vue_mountComponent(root);

                // bring in the global styling
                requestAnimationFrame(function () {
                    return this$1.vue_applyStyle(root);
                });
            }

            /**
             * mount a Vue `component` inside the given `container`. This is analgous
             * to ReactDOM.render.
             */

        }, {
            key: 'vue_mountComponent',
            value: function vue_mountComponent(container) {

                // `tmp` will get replaced by the DOM generated from the component
                var tmp = document.createElement('tmp');
                tmp.style.display = 'none';
                container.appendChild(tmp);

                this.vue_instance.$mount(tmp);

                this.vue_mounted = true;
            }

            /**
             * finds the global style that contains this element's Vue instance's style
             * and style of its sub-components and copies the styles into this
             * element's shadow root, otherwise the global style will not penetrate
             * into the shadow root.
             */

        }, {
            key: 'vue_applyStyle',
            value: function vue_applyStyle(root) {

                // if no components have scoped style
                if (!scopeIds.length) {
                    return;
                }

                var newStyle = document.createElement('style');

                // WebKit hack, requires appending a text node
                newStyle.appendChild(document.createTextNode('/* Vue styles are inside this element\'s CSSStyleSheet */'));

                // newStyle.sheet won't exist unless the element is first appended
                root.appendChild(newStyle);
                var newSheet = newStyle.sheet;
                var newRules = newSheet.cssRules || newSheet.rules;

                // we have to initialize this here (not outside the class) because global
                // styles are added to DOM after the first Vue instance is created
                if (!matchingRules) {
                    matchingRules = getMatchingCSSRules(scopeIds);
                }

                for (var i = 0, list = matchingRules; i < list.length; i += 1) {
                    var rule = list[i];

                    newSheet.insertRule(rule.cssText, newRules.length);
                }

                // TODO: make sure this works with conditional content. Maybe
                // conditional content that isn't rendered yet doesn't have it's
                // styles inserted into DOM???
            }
        }, {
            key: 'updated',
            value: function updated(prevProps, prevState) {
                var this$1 = this;

                (0, _get3.default)(VueWebComponent.prototype.__proto__ || (0, _getPrototypeOf2.default)(VueWebComponent.prototype), 'updated', this).call(this, prevProps, prevState);

                // pass this.props as first arg, whose keys are iterated on in
                // forChangedProps, otherwise nothing happens the first time
                // because prevProps is empty at first.
                forChangedProps(this.props, prevProps, function (name, oldVal) {
                    // pass the value along
                    this$1.vue_instance[name] = this$1[name];
                });
            }
        }], [{
            key: 'props',
            get: function () {
                return vuePropTypes;
            }
        }]);

        return VueWebComponent;
    }((0, _skatejs.withUpdate)((0, _skatejs.withRenderer)(ElementClass)));
}

// a hack class used so we don't conflict with Vue's builtin <slot> component. Is there a better way?

var RealSlot = function (_withLifecycle) {
    (0, _inherits3.default)(RealSlot, _withLifecycle);

    function RealSlot() {
        var args = [],
            len = arguments.length;
        while (len--) args[len] = arguments[len];

        (0, _classCallCheck3.default)(this, RealSlot);

        var _this3 = (0, _possibleConstructorReturn3.default)(this, (ref = RealSlot.__proto__ || (0, _getPrototypeOf2.default)(RealSlot)).call.apply(ref, [this].concat(args)));

        _this3.style.display = 'contents';
        return _this3;
        var ref;
    }

    (0, _createClass3.default)(RealSlot, [{
        key: 'connected',
        value: function connected() {
            if (this.actualSlot) {
                return;
            }
            this.actualSlot = document.createElement('slot');
            this.appendChild(this.actualSlot);
        }
    }, {
        key: 'updated',
        value: function updated(prevProps) {
            if (this.name && this.name !== prevProps.name) {
                this.actualSlot.setAttribute('name', this.name);
            }
        }
    }], [{
        key: 'props',
        get: function () {
            return {
                name: (0, _assign2.default)({}, _skatejs.props.string, { attribute: true })
            };
        }
    }]);

    return RealSlot;
}((0, _skatejs.withLifecycle)((0, _skatejs.withUpdate)(HTMLElement)));

customElements.define('real-slot', RealSlot);

function makeVuePropTypes(vueProps) {
    if (!vueProps) {
        return {};
    }

    var result = {};

    var warn = function () {
        return console.warn('vue-web-component: The Vue component that you converted into a custom element will receive only string values from the "' + key + '" attribute. If you\'d like string values from attributes coerced into a certain type, define that type in your Vue component. For example: props: { "' + key + '": Number }');
    };

    function getDefault(vueProp) {
        // TODO: calling the default value factory and using that single value
        // causes all instanced of the element to use the same cached value for
        // Objects and Arrays. How to fix?
        if (typeof vueProp.default == 'function') {
            return (0, _freeze2.default)(vueProp.default());
        } else {
            return vueProp.default;
        }
    }

    for (var key$1 in vueProps) {
        var prop = vueProps[key$1];
        var defaultVal = getDefault(prop);

        if (prop.type === null) {
            result[key$1] = _skatejs.props.any;
            warn();
            console.warn('vue-web-component: You did not specify a prop type for the attribute mentioned in the previous warning. Any values for this attribute will be passed as a string value to the Vue component.');
        } else if (prop.type === Number) {
            result[key$1] = (0, _assign2.default)({}, _skatejs.props.number, { default: defaultVal });
        } else if (prop.type === String) {
            result[key$1] = (0, _assign2.default)({}, _skatejs.props.string, { default: defaultVal });
        } else if (prop.type === Boolean) {
            result[key$1] = (0, _assign2.default)({}, _skatejs.props.boolean, { default: defaultVal });
        } else if (prop.type === Object) {
            result[key$1] = (0, _assign2.default)({}, _skatejs.props.object, { default: defaultVal });
        } else if (prop.type === Array) {
            result[key$1] = (0, _assign2.default)({}, _skatejs.props.array, { default: defaultVal });
        } else {
            result[key$1] = _skatejs.props.any;
            warn();
            console.warn('vue-web-component: You specified a type in your Vue component that is currently is not supported by vue-web-component. Any values for the attribute mentioned in the previous warning will be passed as string value to the Vue component.');
        }
    }

    return result;
}

function getAllScopeIds(vueComponent) {

    var result = [];

    ~function _getAllScopeIds(vueComponent) {

        if (vueComponent._scopeId) {
            result.push(vueComponent._scopeId);
        }

        for (var subComponent in vueComponent.components) {
            _getAllScopeIds(vueComponent.components[subComponent]);
        }
    }(vueComponent);

    return result;
}

function getMatchingCSSRules(scopeIds) {
    var sheets = document.styleSheets;

    var result = [];

    Array.prototype.forEach.call(sheets, function (sheet) {
        var rules = sheet.cssRules || sheet.rules;

        Array.prototype.forEach.call(rules, function (rule) {

            if (scopeIds.some(function (id) {
                return rule.selectorText.indexOf(id) > -1;
            })) {
                result.push(rule);
            }
        });
    });

    return result;
}

function forChangedProps(oldProps, newProps, action) {
    for (var oldKey in oldProps) {
        if (oldProps[oldKey] !== newProps[oldKey]) {
            action(oldKey, oldProps[oldKey]);
        }
    }
}

// IMPORTANT! keep this line as the last line, it is auto-generated from package.json version.
var version = exports.version = '1.2.0';